#line 1 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/Programme/Eigene Programme PIC32/Bootloader 2/Bootloader v002/Flash.c"
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/types.h"
#line 15 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/types.h"
 typedef struct {
 unsigned short dataLength;
 unsigned short type;
 unsigned long addrSegment;
 unsigned long addrOffset;
 unsigned long realAddess;
 unsigned short hexBinData[16];
 unsigned short checkSum;
 } hexLine_t;

 typedef enum {
 eResultOk = 0,
 eResultLastChunk,
 eErrReadHexLine,
 eErrNoDelimiter,
 eErrChecksum,
 eParseFailed,
 eErrResult
 }enResult;
#line 12 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/Programme/Eigene Programme PIC32/Bootloader 2/Bootloader v002/Flash.c"
unsigned short getPageIndex(unsigned long phyAddress);
unsigned long GetPhyStartPageAddress(unsigned long phyAddress);
unsigned long physicaToKseg1(unsigned long physicalAddr);
void writeShadowToFlash(void);

typedef struct{
 unsigned short blockIndex;
 unsigned long phyPageStartAddr;
 unsigned short shadowBlock[ 0x1000 ];
} shadowFlashBlock_t;


unsigned short m_ProgramFlashBlocksTrace[131];
shadowFlashBlock_t m_shadowPage;
unsigned short m_oneShot =  0 ;


void initShadowMemoriesTraces(){
 unsigned short i;
 for (i=0; i< 131; i++){

 m_ProgramFlashBlocksTrace[i] = 0;
 }
}

void eraseFlashFromUserApplicationStart(){
 unsigned long pageStartAddr =  0x9D00A000 ;
 unsigned short pageIndex = getPageIndex(KVA_TO_PA( 0x9D00A000 ));
 do {
 Flash_Erase_Page(pageStartAddr);
 m_ProgramFlashBlocksTrace[pageIndex] = 1;
 pageStartAddr += 0x1000;
 pageIndex++;
 }while (pageStartAddr < 0x9D07FFFF);
}


void initShadowMemory(){
 initShadowMemoriesTraces();
 m_oneShot =  0 ;
 eraseFlashFromUserApplicationStart();
}
#line 67 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/Programme/Eigene Programme PIC32/Bootloader 2/Bootloader v002/Flash.c"
void writeDataToShadowOfFlashBlock(hexLine_t *ptrHexObj){
 unsigned long numBytesPageOverflow = 0;
 unsigned short dataBlockIndex;
 unsigned long offsetInPage;
 unsigned long *ulPtr;

 dataBlockIndex = getPageIndex(ptrHexObj->realAddess);

 if (m_oneShot ==  0 ){
 m_shadowPage.phyPageStartAddr = GetPhyStartPageAddress(ptrHexObj->realAddess);
 ulPtr = physicaToKseg1(m_shadowPage.phyPageStartAddr);
 memcpy(m_shadowPage.shadowBlock,ulPtr,  0x1000 );
 m_shadowPage.blockIndex = dataBlockIndex;
 m_oneShot =  1 ;
 }

 if(m_shadowPage.blockIndex != dataBlockIndex){







 writeShadowToFlash();


 m_shadowPage.phyPageStartAddr = GetPhyStartPageAddress(ptrHexObj->realAddess);
 ulPtr = physicaToKseg1(m_shadowPage.phyPageStartAddr);
 memcpy(m_shadowPage.shadowBlock, ulPtr,  0x1000 );
 m_shadowPage.blockIndex = dataBlockIndex;
 }


 offsetInPage = ptrHexObj->realAddess - m_shadowPage.phyPageStartAddr;
 if ( (offsetInPage + ptrHexObj->dataLength) >  0x1000 ){
 numBytesPageOverflow = offsetInPage + ptrHexObj->dataLength -  0x1000 ;

 memcpy(& m_shadowPage.shadowBlock[offsetInPage], ptrHexObj->hexBinData,ptrHexObj->dataLength - numBytesPageOverflow);






 writeShadowToFlash();


 m_shadowPage.phyPageStartAddr += 0x1000;
 ulPtr = physicaToKseg1(m_shadowPage.phyPageStartAddr);
 memcpy(m_shadowPage.shadowBlock, ulPtr,  0x1000 );
 m_shadowPage.blockIndex ++;


 ulPtr = ptrHexObj->hexBinData + (ptrHexObj->dataLength - numBytesPageOverflow);
 memcpy(m_shadowPage.shadowBlock, ulPtr, numBytesPageOverflow);
 } else{

 memcpy(& m_shadowPage.shadowBlock[offsetInPage], ptrHexObj->hexBinData, ptrHexObj->dataLength);
 }
}

void writeShadowToFlash(void) {
 unsigned long i;
 unsigned long virtualAddrOfPageStart;

 virtualAddrOfPageStart = physicaToKseg1(m_shadowPage.phyPageStartAddr);

 if (m_ProgramFlashBlocksTrace[m_shadowPage.blockIndex] == 0){
 Flash_Erase_Page(virtualAddrOfPageStart);
 m_ProgramFlashBlocksTrace[m_shadowPage.blockIndex] = 1;
 }

 for (i=0; i<8; i++){
 Flash_Write_Row(virtualAddrOfPageStart + i*512, & m_shadowPage.shadowBlock[512 *i]);
 }
}

 unsigned long GetPhyStartPageAddress(unsigned long phyAddress){

 return phyAddress & ~( 0x1000  -1);
 }

 unsigned short getPageIndex(unsigned long phyAddress){
 if (phyAddress <  0x1FC00000 ){
 return (unsigned short) ((phyAddress -  0x1D000000 )>>12);
 } else {
 return (unsigned short)(((phyAddress -  0x1FC00000 ) >>12)) +128;
 }
 }

 unsigned long physicaToKseg1(unsigned long physicalAddr){

 return physicalAddr | 0x80000000;
 }
